import { Store } from "@/types";

let _inited = false;

// for dev
const _store = {
  globalMask: false,
  env: {
    loginName: "",
    password: "",
    server: { host: "", name: "" },
    user: {} as Store["env"]["user"],
    exam: {} as Store["env"]["exam"],
    examId: -1,
  } as Store["env"],
  config: JSON.parse(JSON.stringify(window.electron.config)) || {},
  pageInputs: {} as Store["pageInputs"],
  syncTime: [],
} as Store;

// for dev
// Object.assign(
//   _store,
//   JSON.parse(window.localStorage.getItem("store") || "{}"),
//   { config: JSON.parse(JSON.stringify(window.electron.config)) || {} } // use 最新的config
// );

const handler = function () {
  return {
    set(obj: any, prop: any, value: any) {
      // console.log("set", obj, prop, value);
      obj[prop] = value;
      window.localStorage.setItem("store", JSON.stringify(_store));
      return true;
    },
    get(obj: any, prop: any): any {
      // console.log("get", obj, prop);
      if (!_inited) {
        Object.assign(
          _store,
          JSON.parse(window.localStorage.getItem("store") || "{}"),
          { config: JSON.parse(JSON.stringify(window.electron.config)) || {} }, // use 最新的config
          { pageInputs: {} } // 删除pageInputs
        );
        _inited = true;
      }
      if (
        ["[object Object]", "[object Array]"].indexOf(
          Object.prototype.toString.call(obj[prop])
        ) > -1
      ) {
        return new Proxy(obj[prop], handler());
      }
      return obj[prop];
    },
  };
};
const store = new Proxy(_store, handler()) as Store;

export { store };

window.store = store;
